#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

static void ATL_cJIK0x0x57TN1x1x6_a1_bX
   (const int M, const int N, const int K, const float alpha, const float * ATL_RESTRICT A, const int lda, const float * ATL_RESTRICT B, const int ldb, const float beta, float * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=0, NB=0, KB=57, 
 * lda=57, ldb=57, ldc=0, mu=1, nu=1, ku=6, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.8.4)
 */
{
   #define Mb M
   #define Nb N
   const float *stM = A + (57*(Mb));
   const float *stN = B + (57*(Nb));
   const float *pfA = stM;
   const int incPFA0 = (((int)(stM - A))*1*1)/(M*N*sizeof(float));
   const int incPFA = (1 > incPFA0) ? 1 : incPFA0;
   #define incAk 6
   const int incAm = 3, incAn = -(57*(Mb));
   #define incBk 6
   const int incBm = -54, incBn = 57;
   #define incCm 2
   const int incCn = (((ldc) << 1)) - (((Mb) << 1));
   float *pC0=C;
   const float *pA0=A;
   const float *pB0=B;
   register int k;
   register float rA0;
   register float rB0;
   register float rC0_0;
   do /* N-loop */
   {
      do /* M-loop */
      {
         ATL_pfl1R(pfA);
         pfA += incPFA;
         rA0 = beta;
         rC0_0 = *pC0;
         rC0_0 *= rA0;
         for (k=54; k; k -= 6) /* easy loop to unroll */
         {
            rA0 = *pA0;
            rB0 = *pB0;
            rC0_0 += rA0 * rB0;
            rA0 = pA0[1];
            rB0 = pB0[1];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[2];
            rB0 = pB0[2];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[3];
            rB0 = pB0[3];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[4];
            rB0 = pB0[4];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[5];
            rB0 = pB0[5];
            rC0_0 += rA0 * rB0;
            pA0 += incAk;
            pB0 += incBk;
         }
         rA0 = *pA0;
         rB0 = *pB0;
         rC0_0 += rA0 * rB0;
         rA0 = pA0[1];
         rB0 = pB0[1];
         rC0_0 += rA0 * rB0;
         rA0 = pA0[2];
         rB0 = pB0[2];
         rC0_0 += rA0 * rB0;
         *pC0 = rC0_0;
         pC0 += incCm;
         pA0 += incAm;
         pB0 += incBm;
      }
      while(pA0 != stM);
      pC0 += incCn;
      pA0 += incAn;
      pB0 += incBn;
   }
   while(pB0 != stN);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
void ATL_cJIK0x0x57TN57x57x0_a1_bX
   (const int M, const int N, const int K, const float alpha, const float * ATL_RESTRICT A, const int lda, const float * ATL_RESTRICT B, const int ldb, const float beta, float * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=0, NB=0, KB=57, 
 * lda=57, ldb=57, ldc=0, mu=1, nu=10, ku=6, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.8.4)
 */
{
   #define Mb M
   const int Nb = (N/10)*10;
   const float *ca=A, *cb=B;
   float *cc=C;
   const float *stM = A + (57*(Mb));
   const float *stN = B + (57*(Nb));
   const float *pfA = stM;
   const int incPFA0 = (((int)(stM - A))*1*10)/(M*N*sizeof(float));
   const int incPFA = (1 > incPFA0) ? 1 : incPFA0;
   #define incAk 6
   const int incAm = 3, incAn = -(57*(Mb));
   #define incBk 6
   const int incBm = -54, incBn = 570;
   #define incCm 2
   const int incCn = (((ldc) << 4)+((ldc) << 2)) - (((Mb) << 1));
   float *pC0=C, *pC1=pC0+(((ldc) << 1)), *pC2=pC1+(((ldc) << 1)), *pC3=pC2+(((ldc) << 1)), *pC4=pC3+(((ldc) << 1)), *pC5=pC4+(((ldc) << 1)), *pC6=pC5+(((ldc) << 1)), *pC7=pC6+(((ldc) << 1)), *pC8=pC7+(((ldc) << 1)), *pC9=pC8+(((ldc) << 1));
   const float *pA0=A;
   const float *pB0=B;
   register int k;
   register float rA0;
   register float rB0, rB1, rB2, rB3, rB4, rB5, rB6, rB7, rB8, rB9;
   register float rC0_0, rC0_1, rC0_2, rC0_3, rC0_4, rC0_5, rC0_6, rC0_7, rC0_8, rC0_9;
   if (pB0 != stN)
   {
      do /* N-loop */
      {
         do /* M-loop */
         {
            ATL_pfl1R(pfA);
            pfA += incPFA;
            rA0 = beta;
            rC0_0 = *pC0;
            rC0_0 *= rA0;
            rC0_1 = *pC1;
            rC0_1 *= rA0;
            rC0_2 = *pC2;
            rC0_2 *= rA0;
            rC0_3 = *pC3;
            rC0_3 *= rA0;
            rC0_4 = *pC4;
            rC0_4 *= rA0;
            rC0_5 = *pC5;
            rC0_5 *= rA0;
            rC0_6 = *pC6;
            rC0_6 *= rA0;
            rC0_7 = *pC7;
            rC0_7 *= rA0;
            rC0_8 = *pC8;
            rC0_8 *= rA0;
            rC0_9 = *pC9;
            rC0_9 *= rA0;
            for (k=54; k; k -= 6) /* easy loop to unroll */
            {
               rA0 = *pA0;
               rB0 = *pB0;
               rB1 = pB0[57];
               rB2 = pB0[114];
               rB3 = pB0[171];
               rB4 = pB0[228];
               rB5 = pB0[285];
               rB6 = pB0[342];
               rC0_0 += rA0 * rB0;
               rB7 = pB0[399];
               rB8 = pB0[456];
               rB9 = pB0[513];
               rC0_1 += rA0 * rB1;
               rC0_2 += rA0 * rB2;
               rC0_3 += rA0 * rB3;
               rC0_4 += rA0 * rB4;
               rC0_5 += rA0 * rB5;
               rC0_6 += rA0 * rB6;
               rC0_7 += rA0 * rB7;
               rC0_8 += rA0 * rB8;
               rC0_9 += rA0 * rB9;
               rA0 = pA0[1];
               rB0 = pB0[1];
               rB1 = pB0[58];
               rB2 = pB0[115];
               rB3 = pB0[172];
               rB4 = pB0[229];
               rB5 = pB0[286];
               rB6 = pB0[343];
               rC0_0 += rA0 * rB0;
               rB7 = pB0[400];
               rB8 = pB0[457];
               rB9 = pB0[514];
               rC0_1 += rA0 * rB1;
               rC0_2 += rA0 * rB2;
               rC0_3 += rA0 * rB3;
               rC0_4 += rA0 * rB4;
               rC0_5 += rA0 * rB5;
               rC0_6 += rA0 * rB6;
               rC0_7 += rA0 * rB7;
               rC0_8 += rA0 * rB8;
               rC0_9 += rA0 * rB9;
               rA0 = pA0[2];
               rB0 = pB0[2];
               rB1 = pB0[59];
               rB2 = pB0[116];
               rB3 = pB0[173];
               rB4 = pB0[230];
               rB5 = pB0[287];
               rB6 = pB0[344];
               rC0_0 += rA0 * rB0;
               rB7 = pB0[401];
               rB8 = pB0[458];
               rB9 = pB0[515];
               rC0_1 += rA0 * rB1;
               rC0_2 += rA0 * rB2;
               rC0_3 += rA0 * rB3;
               rC0_4 += rA0 * rB4;
               rC0_5 += rA0 * rB5;
               rC0_6 += rA0 * rB6;
               rC0_7 += rA0 * rB7;
               rC0_8 += rA0 * rB8;
               rC0_9 += rA0 * rB9;
               rA0 = pA0[3];
               rB0 = pB0[3];
               rB1 = pB0[60];
               rB2 = pB0[117];
               rB3 = pB0[174];
               rB4 = pB0[231];
               rB5 = pB0[288];
               rB6 = pB0[345];
               rC0_0 += rA0 * rB0;
               rB7 = pB0[402];
               rB8 = pB0[459];
               rB9 = pB0[516];
               rC0_1 += rA0 * rB1;
               rC0_2 += rA0 * rB2;
               rC0_3 += rA0 * rB3;
               rC0_4 += rA0 * rB4;
               rC0_5 += rA0 * rB5;
               rC0_6 += rA0 * rB6;
               rC0_7 += rA0 * rB7;
               rC0_8 += rA0 * rB8;
               rC0_9 += rA0 * rB9;
               rA0 = pA0[4];
               rB0 = pB0[4];
               rB1 = pB0[61];
               rB2 = pB0[118];
               rB3 = pB0[175];
               rB4 = pB0[232];
               rB5 = pB0[289];
               rB6 = pB0[346];
               rC0_0 += rA0 * rB0;
               rB7 = pB0[403];
               rB8 = pB0[460];
               rB9 = pB0[517];
               rC0_1 += rA0 * rB1;
               rC0_2 += rA0 * rB2;
               rC0_3 += rA0 * rB3;
               rC0_4 += rA0 * rB4;
               rC0_5 += rA0 * rB5;
               rC0_6 += rA0 * rB6;
               rC0_7 += rA0 * rB7;
               rC0_8 += rA0 * rB8;
               rC0_9 += rA0 * rB9;
               rA0 = pA0[5];
               rB0 = pB0[5];
               rB1 = pB0[62];
               rB2 = pB0[119];
               rB3 = pB0[176];
               rB4 = pB0[233];
               rB5 = pB0[290];
               rB6 = pB0[347];
               rC0_0 += rA0 * rB0;
               rB7 = pB0[404];
               rB8 = pB0[461];
               rB9 = pB0[518];
               rC0_1 += rA0 * rB1;
               rC0_2 += rA0 * rB2;
               rC0_3 += rA0 * rB3;
               rC0_4 += rA0 * rB4;
               rC0_5 += rA0 * rB5;
               rC0_6 += rA0 * rB6;
               rC0_7 += rA0 * rB7;
               rC0_8 += rA0 * rB8;
               rC0_9 += rA0 * rB9;
               pA0 += incAk;
               pB0 += incBk;
            }
            rA0 = *pA0;
            rB0 = *pB0;
            rB1 = pB0[57];
            rB2 = pB0[114];
            rB3 = pB0[171];
            rB4 = pB0[228];
            rB5 = pB0[285];
            rB6 = pB0[342];
            rC0_0 += rA0 * rB0;
            rB7 = pB0[399];
            rB8 = pB0[456];
            rB9 = pB0[513];
            rC0_1 += rA0 * rB1;
            rC0_2 += rA0 * rB2;
            rC0_3 += rA0 * rB3;
            rC0_4 += rA0 * rB4;
            rC0_5 += rA0 * rB5;
            rC0_6 += rA0 * rB6;
            rC0_7 += rA0 * rB7;
            rC0_8 += rA0 * rB8;
            rC0_9 += rA0 * rB9;
            rA0 = pA0[1];
            rB0 = pB0[1];
            rB1 = pB0[58];
            rB2 = pB0[115];
            rB3 = pB0[172];
            rB4 = pB0[229];
            rB5 = pB0[286];
            rB6 = pB0[343];
            rC0_0 += rA0 * rB0;
            rB7 = pB0[400];
            rB8 = pB0[457];
            rB9 = pB0[514];
            rC0_1 += rA0 * rB1;
            rC0_2 += rA0 * rB2;
            rC0_3 += rA0 * rB3;
            rC0_4 += rA0 * rB4;
            rC0_5 += rA0 * rB5;
            rC0_6 += rA0 * rB6;
            rC0_7 += rA0 * rB7;
            rC0_8 += rA0 * rB8;
            rC0_9 += rA0 * rB9;
            rA0 = pA0[2];
            rB0 = pB0[2];
            rB1 = pB0[59];
            rB2 = pB0[116];
            rB3 = pB0[173];
            rB4 = pB0[230];
            rB5 = pB0[287];
            rB6 = pB0[344];
            rC0_0 += rA0 * rB0;
            rB7 = pB0[401];
            rB8 = pB0[458];
            rB9 = pB0[515];
            rC0_1 += rA0 * rB1;
            rC0_2 += rA0 * rB2;
            rC0_3 += rA0 * rB3;
            rC0_4 += rA0 * rB4;
            rC0_5 += rA0 * rB5;
            rC0_6 += rA0 * rB6;
            rC0_7 += rA0 * rB7;
            rC0_8 += rA0 * rB8;
            rC0_9 += rA0 * rB9;
            *pC0 = rC0_0;
            *pC1 = rC0_1;
            *pC2 = rC0_2;
            *pC3 = rC0_3;
            *pC4 = rC0_4;
            *pC5 = rC0_5;
            *pC6 = rC0_6;
            *pC7 = rC0_7;
            *pC8 = rC0_8;
            *pC9 = rC0_9;
            pC0 += incCm;
            pC1 += incCm;
            pC2 += incCm;
            pC3 += incCm;
            pC4 += incCm;
            pC5 += incCm;
            pC6 += incCm;
            pC7 += incCm;
            pC8 += incCm;
            pC9 += incCm;
            pA0 += incAm;
            pB0 += incBm;
         }
         while(pA0 != stM);
         pC0 += incCn;
         pC1 += incCn;
         pC2 += incCn;
         pC3 += incCn;
         pC4 += incCn;
         pC5 += incCn;
         pC6 += incCn;
         pC7 += incCn;
         pC8 += incCn;
         pC9 += incCn;
         pA0 += incAn;
         pB0 += incBn;
      }
      while(pB0 != stN);
   }
   if (k=N-Nb)
      ATL_cJIK0x0x57TN1x1x6_a1_bX(M, k, 57, alpha, ca, lda, cb + (57*(Nb)), ldb, beta, cc + (((Nb*ldc) << 1)), ldc);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
