#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

static void ATL_cJIK0x0x63TN1x1x6_a1_bX
   (const int M, const int N, const int K, const float alpha, const float * ATL_RESTRICT A, const int lda, const float * ATL_RESTRICT B, const int ldb, const float beta, float * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=0, NB=0, KB=63, 
 * lda=63, ldb=63, ldc=0, mu=1, nu=1, ku=6, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.8.4)
 */
{
   #define Mb M
   #define Nb N
   const float *stM = A + (63*(Mb));
   const float *stN = B + (63*(Nb));
   const float *pfA = stM;
   const int incPFA0 = (((int)(stM - A))*1*1)/(M*N*sizeof(float));
   const int incPFA = (1 > incPFA0) ? 1 : incPFA0;
   #define incAk 6
   const int incAm = 3, incAn = -(63*(Mb));
   #define incBk 6
   const int incBm = -60, incBn = 63;
   #define incCm 2
   const int incCn = (((ldc) << 1)) - (((Mb) << 1));
   float *pC0=C;
   const float *pA0=A;
   const float *pB0=B;
   register int k;
   register float rA0;
   register float rB0;
   register float rC0_0;
   do /* N-loop */
   {
      do /* M-loop */
      {
         ATL_pfl1R(pfA);
         pfA += incPFA;
         rA0 = beta;
         rC0_0 = *pC0;
         rC0_0 *= rA0;
         for (k=60; k; k -= 6) /* easy loop to unroll */
         {
            rA0 = *pA0;
            rB0 = *pB0;
            rC0_0 += rA0 * rB0;
            rA0 = pA0[1];
            rB0 = pB0[1];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[2];
            rB0 = pB0[2];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[3];
            rB0 = pB0[3];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[4];
            rB0 = pB0[4];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[5];
            rB0 = pB0[5];
            rC0_0 += rA0 * rB0;
            pA0 += incAk;
            pB0 += incBk;
         }
         rA0 = *pA0;
         rB0 = *pB0;
         rC0_0 += rA0 * rB0;
         rA0 = pA0[1];
         rB0 = pB0[1];
         rC0_0 += rA0 * rB0;
         rA0 = pA0[2];
         rB0 = pB0[2];
         rC0_0 += rA0 * rB0;
         *pC0 = rC0_0;
         pC0 += incCm;
         pA0 += incAm;
         pB0 += incBm;
      }
      while(pA0 != stM);
      pC0 += incCn;
      pA0 += incAn;
      pB0 += incBn;
   }
   while(pB0 != stN);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
void ATL_cJIK0x0x63TN63x63x0_a1_bX
   (const int M, const int N, const int K, const float alpha, const float * ATL_RESTRICT A, const int lda, const float * ATL_RESTRICT B, const int ldb, const float beta, float * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=0, NB=0, KB=63, 
 * lda=63, ldb=63, ldc=0, mu=1, nu=10, ku=6, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.8.4)
 */
{
   #define Mb M
   const int Nb = (N/10)*10;
   const float *ca=A, *cb=B;
   float *cc=C;
   const float *stM = A + (63*(Mb));
   const float *stN = B + (63*(Nb));
   const float *pfA = stM;
   const int incPFA0 = (((int)(stM - A))*1*10)/(M*N*sizeof(float));
   const int incPFA = (1 > incPFA0) ? 1 : incPFA0;
   #define incAk 6
   const int incAm = 3, incAn = -(63*(Mb));
   #define incBk 6
   const int incBm = -60, incBn = 630;
   #define incCm 2
   const int incCn = (((ldc) << 4)+((ldc) << 2)) - (((Mb) << 1));
   float *pC0=C, *pC1=pC0+(((ldc) << 1)), *pC2=pC1+(((ldc) << 1)), *pC3=pC2+(((ldc) << 1)), *pC4=pC3+(((ldc) << 1)), *pC5=pC4+(((ldc) << 1)), *pC6=pC5+(((ldc) << 1)), *pC7=pC6+(((ldc) << 1)), *pC8=pC7+(((ldc) << 1)), *pC9=pC8+(((ldc) << 1));
   const float *pA0=A;
   const float *pB0=B;
   register int k;
   register float rA0;
   register float rB0, rB1, rB2, rB3, rB4, rB5, rB6, rB7, rB8, rB9;
   register float rC0_0, rC0_1, rC0_2, rC0_3, rC0_4, rC0_5, rC0_6, rC0_7, rC0_8, rC0_9;
   if (pB0 != stN)
   {
      do /* N-loop */
      {
         do /* M-loop */
         {
            ATL_pfl1R(pfA);
            pfA += incPFA;
            rA0 = beta;
            rC0_0 = *pC0;
            rC0_0 *= rA0;
            rC0_1 = *pC1;
            rC0_1 *= rA0;
            rC0_2 = *pC2;
            rC0_2 *= rA0;
            rC0_3 = *pC3;
            rC0_3 *= rA0;
            rC0_4 = *pC4;
            rC0_4 *= rA0;
            rC0_5 = *pC5;
            rC0_5 *= rA0;
            rC0_6 = *pC6;
            rC0_6 *= rA0;
            rC0_7 = *pC7;
            rC0_7 *= rA0;
            rC0_8 = *pC8;
            rC0_8 *= rA0;
            rC0_9 = *pC9;
            rC0_9 *= rA0;
            for (k=60; k; k -= 6) /* easy loop to unroll */
            {
               rA0 = *pA0;
               rB0 = *pB0;
               rB1 = pB0[63];
               rB2 = pB0[126];
               rB3 = pB0[189];
               rB4 = pB0[252];
               rB5 = pB0[315];
               rB6 = pB0[378];
               rC0_0 += rA0 * rB0;
               rB7 = pB0[441];
               rB8 = pB0[504];
               rB9 = pB0[567];
               rC0_1 += rA0 * rB1;
               rC0_2 += rA0 * rB2;
               rC0_3 += rA0 * rB3;
               rC0_4 += rA0 * rB4;
               rC0_5 += rA0 * rB5;
               rC0_6 += rA0 * rB6;
               rC0_7 += rA0 * rB7;
               rC0_8 += rA0 * rB8;
               rC0_9 += rA0 * rB9;
               rA0 = pA0[1];
               rB0 = pB0[1];
               rB1 = pB0[64];
               rB2 = pB0[127];
               rB3 = pB0[190];
               rB4 = pB0[253];
               rB5 = pB0[316];
               rB6 = pB0[379];
               rC0_0 += rA0 * rB0;
               rB7 = pB0[442];
               rB8 = pB0[505];
               rB9 = pB0[568];
               rC0_1 += rA0 * rB1;
               rC0_2 += rA0 * rB2;
               rC0_3 += rA0 * rB3;
               rC0_4 += rA0 * rB4;
               rC0_5 += rA0 * rB5;
               rC0_6 += rA0 * rB6;
               rC0_7 += rA0 * rB7;
               rC0_8 += rA0 * rB8;
               rC0_9 += rA0 * rB9;
               rA0 = pA0[2];
               rB0 = pB0[2];
               rB1 = pB0[65];
               rB2 = pB0[128];
               rB3 = pB0[191];
               rB4 = pB0[254];
               rB5 = pB0[317];
               rB6 = pB0[380];
               rC0_0 += rA0 * rB0;
               rB7 = pB0[443];
               rB8 = pB0[506];
               rB9 = pB0[569];
               rC0_1 += rA0 * rB1;
               rC0_2 += rA0 * rB2;
               rC0_3 += rA0 * rB3;
               rC0_4 += rA0 * rB4;
               rC0_5 += rA0 * rB5;
               rC0_6 += rA0 * rB6;
               rC0_7 += rA0 * rB7;
               rC0_8 += rA0 * rB8;
               rC0_9 += rA0 * rB9;
               rA0 = pA0[3];
               rB0 = pB0[3];
               rB1 = pB0[66];
               rB2 = pB0[129];
               rB3 = pB0[192];
               rB4 = pB0[255];
               rB5 = pB0[318];
               rB6 = pB0[381];
               rC0_0 += rA0 * rB0;
               rB7 = pB0[444];
               rB8 = pB0[507];
               rB9 = pB0[570];
               rC0_1 += rA0 * rB1;
               rC0_2 += rA0 * rB2;
               rC0_3 += rA0 * rB3;
               rC0_4 += rA0 * rB4;
               rC0_5 += rA0 * rB5;
               rC0_6 += rA0 * rB6;
               rC0_7 += rA0 * rB7;
               rC0_8 += rA0 * rB8;
               rC0_9 += rA0 * rB9;
               rA0 = pA0[4];
               rB0 = pB0[4];
               rB1 = pB0[67];
               rB2 = pB0[130];
               rB3 = pB0[193];
               rB4 = pB0[256];
               rB5 = pB0[319];
               rB6 = pB0[382];
               rC0_0 += rA0 * rB0;
               rB7 = pB0[445];
               rB8 = pB0[508];
               rB9 = pB0[571];
               rC0_1 += rA0 * rB1;
               rC0_2 += rA0 * rB2;
               rC0_3 += rA0 * rB3;
               rC0_4 += rA0 * rB4;
               rC0_5 += rA0 * rB5;
               rC0_6 += rA0 * rB6;
               rC0_7 += rA0 * rB7;
               rC0_8 += rA0 * rB8;
               rC0_9 += rA0 * rB9;
               rA0 = pA0[5];
               rB0 = pB0[5];
               rB1 = pB0[68];
               rB2 = pB0[131];
               rB3 = pB0[194];
               rB4 = pB0[257];
               rB5 = pB0[320];
               rB6 = pB0[383];
               rC0_0 += rA0 * rB0;
               rB7 = pB0[446];
               rB8 = pB0[509];
               rB9 = pB0[572];
               rC0_1 += rA0 * rB1;
               rC0_2 += rA0 * rB2;
               rC0_3 += rA0 * rB3;
               rC0_4 += rA0 * rB4;
               rC0_5 += rA0 * rB5;
               rC0_6 += rA0 * rB6;
               rC0_7 += rA0 * rB7;
               rC0_8 += rA0 * rB8;
               rC0_9 += rA0 * rB9;
               pA0 += incAk;
               pB0 += incBk;
            }
            rA0 = *pA0;
            rB0 = *pB0;
            rB1 = pB0[63];
            rB2 = pB0[126];
            rB3 = pB0[189];
            rB4 = pB0[252];
            rB5 = pB0[315];
            rB6 = pB0[378];
            rC0_0 += rA0 * rB0;
            rB7 = pB0[441];
            rB8 = pB0[504];
            rB9 = pB0[567];
            rC0_1 += rA0 * rB1;
            rC0_2 += rA0 * rB2;
            rC0_3 += rA0 * rB3;
            rC0_4 += rA0 * rB4;
            rC0_5 += rA0 * rB5;
            rC0_6 += rA0 * rB6;
            rC0_7 += rA0 * rB7;
            rC0_8 += rA0 * rB8;
            rC0_9 += rA0 * rB9;
            rA0 = pA0[1];
            rB0 = pB0[1];
            rB1 = pB0[64];
            rB2 = pB0[127];
            rB3 = pB0[190];
            rB4 = pB0[253];
            rB5 = pB0[316];
            rB6 = pB0[379];
            rC0_0 += rA0 * rB0;
            rB7 = pB0[442];
            rB8 = pB0[505];
            rB9 = pB0[568];
            rC0_1 += rA0 * rB1;
            rC0_2 += rA0 * rB2;
            rC0_3 += rA0 * rB3;
            rC0_4 += rA0 * rB4;
            rC0_5 += rA0 * rB5;
            rC0_6 += rA0 * rB6;
            rC0_7 += rA0 * rB7;
            rC0_8 += rA0 * rB8;
            rC0_9 += rA0 * rB9;
            rA0 = pA0[2];
            rB0 = pB0[2];
            rB1 = pB0[65];
            rB2 = pB0[128];
            rB3 = pB0[191];
            rB4 = pB0[254];
            rB5 = pB0[317];
            rB6 = pB0[380];
            rC0_0 += rA0 * rB0;
            rB7 = pB0[443];
            rB8 = pB0[506];
            rB9 = pB0[569];
            rC0_1 += rA0 * rB1;
            rC0_2 += rA0 * rB2;
            rC0_3 += rA0 * rB3;
            rC0_4 += rA0 * rB4;
            rC0_5 += rA0 * rB5;
            rC0_6 += rA0 * rB6;
            rC0_7 += rA0 * rB7;
            rC0_8 += rA0 * rB8;
            rC0_9 += rA0 * rB9;
            *pC0 = rC0_0;
            *pC1 = rC0_1;
            *pC2 = rC0_2;
            *pC3 = rC0_3;
            *pC4 = rC0_4;
            *pC5 = rC0_5;
            *pC6 = rC0_6;
            *pC7 = rC0_7;
            *pC8 = rC0_8;
            *pC9 = rC0_9;
            pC0 += incCm;
            pC1 += incCm;
            pC2 += incCm;
            pC3 += incCm;
            pC4 += incCm;
            pC5 += incCm;
            pC6 += incCm;
            pC7 += incCm;
            pC8 += incCm;
            pC9 += incCm;
            pA0 += incAm;
            pB0 += incBm;
         }
         while(pA0 != stM);
         pC0 += incCn;
         pC1 += incCn;
         pC2 += incCn;
         pC3 += incCn;
         pC4 += incCn;
         pC5 += incCn;
         pC6 += incCn;
         pC7 += incCn;
         pC8 += incCn;
         pC9 += incCn;
         pA0 += incAn;
         pB0 += incBn;
      }
      while(pB0 != stN);
   }
   if (k=N-Nb)
      ATL_cJIK0x0x63TN1x1x6_a1_bX(M, k, 63, alpha, ca, lda, cb + (63*(Nb)), ldb, beta, cc + (((Nb*ldc) << 1)), ldc);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
