#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

void ATL_sJIK40x40x40TN40x40x0_a1_bX
   (const int M, const int N, const int K, const float alpha, const float * ATL_RESTRICT A, const int lda, const float * ATL_RESTRICT B, const int ldb, const float beta, float * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=40, NB=40, KB=40, 
 * lda=40, ldb=40, ldc=0, mu=1, nu=10, ku=6, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.8.4)
 */
{
   const float *stM = A + 1600;
   const float *stN = B + 1600;
   const float *pfA = stM;
   const int incPFA0 = (((int)(stM - A))*1*10)/(40*40);
   const int incPFA = (1 > incPFA0) ? 1 : incPFA0;
   #define incAk 6
   const int incAm = 4, incAn = -1600;
   #define incBk 6
   const int incBm = -36, incBn = 400;
   #define incCm 1
   const int incCn = (((ldc) << 3)+((ldc) << 1)) - 40;
   float *pC0=C, *pC1=pC0+(ldc), *pC2=pC1+(ldc), *pC3=pC2+(ldc), *pC4=pC3+(ldc), *pC5=pC4+(ldc), *pC6=pC5+(ldc), *pC7=pC6+(ldc), *pC8=pC7+(ldc), *pC9=pC8+(ldc);
   const float *pA0=A;
   const float *pB0=B;
   register int k;
   register float rA0;
   register float rB0, rB1, rB2, rB3, rB4, rB5, rB6, rB7, rB8, rB9;
   register float rC0_0, rC0_1, rC0_2, rC0_3, rC0_4, rC0_5, rC0_6, rC0_7, rC0_8, rC0_9;
   do /* N-loop */
   {
      do /* M-loop */
      {
         ATL_pfl1R(pfA);
         pfA += incPFA;
         rA0 = beta;
         rC0_0 = *pC0;
         rC0_0 *= rA0;
         rC0_1 = *pC1;
         rC0_1 *= rA0;
         rC0_2 = *pC2;
         rC0_2 *= rA0;
         rC0_3 = *pC3;
         rC0_3 *= rA0;
         rC0_4 = *pC4;
         rC0_4 *= rA0;
         rC0_5 = *pC5;
         rC0_5 *= rA0;
         rC0_6 = *pC6;
         rC0_6 *= rA0;
         rC0_7 = *pC7;
         rC0_7 *= rA0;
         rC0_8 = *pC8;
         rC0_8 *= rA0;
         rC0_9 = *pC9;
         rC0_9 *= rA0;
         for (k=36; k; k -= 6) /* easy loop to unroll */
         {
            rA0 = *pA0;
            rB0 = *pB0;
            rB1 = pB0[40];
            rB2 = pB0[80];
            rB3 = pB0[120];
            rB4 = pB0[160];
            rB5 = pB0[200];
            rB6 = pB0[240];
            rC0_0 += rA0 * rB0;
            rB7 = pB0[280];
            rB8 = pB0[320];
            rB9 = pB0[360];
            rC0_1 += rA0 * rB1;
            rC0_2 += rA0 * rB2;
            rC0_3 += rA0 * rB3;
            rC0_4 += rA0 * rB4;
            rC0_5 += rA0 * rB5;
            rC0_6 += rA0 * rB6;
            rC0_7 += rA0 * rB7;
            rC0_8 += rA0 * rB8;
            rC0_9 += rA0 * rB9;
            rA0 = pA0[1];
            rB0 = pB0[1];
            rB1 = pB0[41];
            rB2 = pB0[81];
            rB3 = pB0[121];
            rB4 = pB0[161];
            rB5 = pB0[201];
            rB6 = pB0[241];
            rC0_0 += rA0 * rB0;
            rB7 = pB0[281];
            rB8 = pB0[321];
            rB9 = pB0[361];
            rC0_1 += rA0 * rB1;
            rC0_2 += rA0 * rB2;
            rC0_3 += rA0 * rB3;
            rC0_4 += rA0 * rB4;
            rC0_5 += rA0 * rB5;
            rC0_6 += rA0 * rB6;
            rC0_7 += rA0 * rB7;
            rC0_8 += rA0 * rB8;
            rC0_9 += rA0 * rB9;
            rA0 = pA0[2];
            rB0 = pB0[2];
            rB1 = pB0[42];
            rB2 = pB0[82];
            rB3 = pB0[122];
            rB4 = pB0[162];
            rB5 = pB0[202];
            rB6 = pB0[242];
            rC0_0 += rA0 * rB0;
            rB7 = pB0[282];
            rB8 = pB0[322];
            rB9 = pB0[362];
            rC0_1 += rA0 * rB1;
            rC0_2 += rA0 * rB2;
            rC0_3 += rA0 * rB3;
            rC0_4 += rA0 * rB4;
            rC0_5 += rA0 * rB5;
            rC0_6 += rA0 * rB6;
            rC0_7 += rA0 * rB7;
            rC0_8 += rA0 * rB8;
            rC0_9 += rA0 * rB9;
            rA0 = pA0[3];
            rB0 = pB0[3];
            rB1 = pB0[43];
            rB2 = pB0[83];
            rB3 = pB0[123];
            rB4 = pB0[163];
            rB5 = pB0[203];
            rB6 = pB0[243];
            rC0_0 += rA0 * rB0;
            rB7 = pB0[283];
            rB8 = pB0[323];
            rB9 = pB0[363];
            rC0_1 += rA0 * rB1;
            rC0_2 += rA0 * rB2;
            rC0_3 += rA0 * rB3;
            rC0_4 += rA0 * rB4;
            rC0_5 += rA0 * rB5;
            rC0_6 += rA0 * rB6;
            rC0_7 += rA0 * rB7;
            rC0_8 += rA0 * rB8;
            rC0_9 += rA0 * rB9;
            rA0 = pA0[4];
            rB0 = pB0[4];
            rB1 = pB0[44];
            rB2 = pB0[84];
            rB3 = pB0[124];
            rB4 = pB0[164];
            rB5 = pB0[204];
            rB6 = pB0[244];
            rC0_0 += rA0 * rB0;
            rB7 = pB0[284];
            rB8 = pB0[324];
            rB9 = pB0[364];
            rC0_1 += rA0 * rB1;
            rC0_2 += rA0 * rB2;
            rC0_3 += rA0 * rB3;
            rC0_4 += rA0 * rB4;
            rC0_5 += rA0 * rB5;
            rC0_6 += rA0 * rB6;
            rC0_7 += rA0 * rB7;
            rC0_8 += rA0 * rB8;
            rC0_9 += rA0 * rB9;
            rA0 = pA0[5];
            rB0 = pB0[5];
            rB1 = pB0[45];
            rB2 = pB0[85];
            rB3 = pB0[125];
            rB4 = pB0[165];
            rB5 = pB0[205];
            rB6 = pB0[245];
            rC0_0 += rA0 * rB0;
            rB7 = pB0[285];
            rB8 = pB0[325];
            rB9 = pB0[365];
            rC0_1 += rA0 * rB1;
            rC0_2 += rA0 * rB2;
            rC0_3 += rA0 * rB3;
            rC0_4 += rA0 * rB4;
            rC0_5 += rA0 * rB5;
            rC0_6 += rA0 * rB6;
            rC0_7 += rA0 * rB7;
            rC0_8 += rA0 * rB8;
            rC0_9 += rA0 * rB9;
            pA0 += incAk;
            pB0 += incBk;
         }
         rA0 = *pA0;
         rB0 = *pB0;
         rB1 = pB0[40];
         rB2 = pB0[80];
         rB3 = pB0[120];
         rB4 = pB0[160];
         rB5 = pB0[200];
         rB6 = pB0[240];
         rC0_0 += rA0 * rB0;
         rB7 = pB0[280];
         rB8 = pB0[320];
         rB9 = pB0[360];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rC0_4 += rA0 * rB4;
         rC0_5 += rA0 * rB5;
         rC0_6 += rA0 * rB6;
         rC0_7 += rA0 * rB7;
         rC0_8 += rA0 * rB8;
         rC0_9 += rA0 * rB9;
         rA0 = pA0[1];
         rB0 = pB0[1];
         rB1 = pB0[41];
         rB2 = pB0[81];
         rB3 = pB0[121];
         rB4 = pB0[161];
         rB5 = pB0[201];
         rB6 = pB0[241];
         rC0_0 += rA0 * rB0;
         rB7 = pB0[281];
         rB8 = pB0[321];
         rB9 = pB0[361];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rC0_4 += rA0 * rB4;
         rC0_5 += rA0 * rB5;
         rC0_6 += rA0 * rB6;
         rC0_7 += rA0 * rB7;
         rC0_8 += rA0 * rB8;
         rC0_9 += rA0 * rB9;
         rA0 = pA0[2];
         rB0 = pB0[2];
         rB1 = pB0[42];
         rB2 = pB0[82];
         rB3 = pB0[122];
         rB4 = pB0[162];
         rB5 = pB0[202];
         rB6 = pB0[242];
         rC0_0 += rA0 * rB0;
         rB7 = pB0[282];
         rB8 = pB0[322];
         rB9 = pB0[362];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rC0_4 += rA0 * rB4;
         rC0_5 += rA0 * rB5;
         rC0_6 += rA0 * rB6;
         rC0_7 += rA0 * rB7;
         rC0_8 += rA0 * rB8;
         rC0_9 += rA0 * rB9;
         rA0 = pA0[3];
         rB0 = pB0[3];
         rB1 = pB0[43];
         rB2 = pB0[83];
         rB3 = pB0[123];
         rB4 = pB0[163];
         rB5 = pB0[203];
         rB6 = pB0[243];
         rC0_0 += rA0 * rB0;
         rB7 = pB0[283];
         rB8 = pB0[323];
         rB9 = pB0[363];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rC0_4 += rA0 * rB4;
         rC0_5 += rA0 * rB5;
         rC0_6 += rA0 * rB6;
         rC0_7 += rA0 * rB7;
         rC0_8 += rA0 * rB8;
         rC0_9 += rA0 * rB9;
         *pC0 = rC0_0;
         *pC1 = rC0_1;
         *pC2 = rC0_2;
         *pC3 = rC0_3;
         *pC4 = rC0_4;
         *pC5 = rC0_5;
         *pC6 = rC0_6;
         *pC7 = rC0_7;
         *pC8 = rC0_8;
         *pC9 = rC0_9;
         pC0 += incCm;
         pC1 += incCm;
         pC2 += incCm;
         pC3 += incCm;
         pC4 += incCm;
         pC5 += incCm;
         pC6 += incCm;
         pC7 += incCm;
         pC8 += incCm;
         pC9 += incCm;
         pA0 += incAm;
         pB0 += incBm;
      }
      while(pA0 != stM);
      pC0 += incCn;
      pC1 += incCn;
      pC2 += incCn;
      pC3 += incCn;
      pC4 += incCn;
      pC5 += incCn;
      pC6 += incCn;
      pC7 += incCn;
      pC8 += incCn;
      pC9 += incCn;
      pA0 += incAn;
      pB0 += incBn;
   }
   while(pB0 != stN);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
