#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

static void ATL_sJIK0x0x36TN1x1x6_a1_bX
   (const int M, const int N, const int K, const float alpha, const float * ATL_RESTRICT A, const int lda, const float * ATL_RESTRICT B, const int ldb, const float beta, float * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=0, NB=0, KB=36, 
 * lda=36, ldb=36, ldc=0, mu=1, nu=1, ku=6, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.8.4)
 */
{
   #define Mb M
   #define Nb N
   const float *stM = A + (((Mb) << 5)+((Mb) << 2));
   const float *stN = B + (((Nb) << 5)+((Nb) << 2));
   const float *pfA = stM;
   const int incPFA0 = (((int)(stM - A))*1*1)/(M*N*sizeof(float));
   const int incPFA = (1 > incPFA0) ? 1 : incPFA0;
   #define incAk 6
   const int incAm = 0, incAn = -(((Mb) << 5)+((Mb) << 2));
   #define incBk 6
   const int incBm = -36, incBn = 36;
   #define incCm 1
   const int incCn = (ldc) - (Mb);
   float *pC0=C;
   const float *pA0=A;
   const float *pB0=B;
   register int k;
   register float rA0;
   register float rB0;
   register float rC0_0;
   do /* N-loop */
   {
      do /* M-loop */
      {
         ATL_pfl1R(pfA);
         pfA += incPFA;
         rA0 = beta;
         rC0_0 = *pC0;
         rC0_0 *= rA0;
         for (k=36; k; k -= 6) /* easy loop to unroll */
         {
            rA0 = *pA0;
            rB0 = *pB0;
            rC0_0 += rA0 * rB0;
            rA0 = pA0[1];
            rB0 = pB0[1];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[2];
            rB0 = pB0[2];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[3];
            rB0 = pB0[3];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[4];
            rB0 = pB0[4];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[5];
            rB0 = pB0[5];
            rC0_0 += rA0 * rB0;
            pA0 += incAk;
            pB0 += incBk;
         }
         *pC0 = rC0_0;
         pC0 += incCm;
         pA0 += incAm;
         pB0 += incBm;
      }
      while(pA0 != stM);
      pC0 += incCn;
      pA0 += incAn;
      pB0 += incBn;
   }
   while(pB0 != stN);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
void ATL_sJIK0x0x36TN36x36x0_a1_bX
   (const int M, const int N, const int K, const float alpha, const float * ATL_RESTRICT A, const int lda, const float * ATL_RESTRICT B, const int ldb, const float beta, float * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=0, NB=0, KB=36, 
 * lda=36, ldb=36, ldc=0, mu=1, nu=10, ku=6, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.8.4)
 */
{
   #define Mb M
   const int Nb = (N/10)*10;
   const float *ca=A, *cb=B;
   float *cc=C;
   const float *stM = A + (((Mb) << 5)+((Mb) << 2));
   const float *stN = B + (((Nb) << 5)+((Nb) << 2));
   const float *pfA = stM;
   const int incPFA0 = (((int)(stM - A))*1*10)/(M*N*sizeof(float));
   const int incPFA = (1 > incPFA0) ? 1 : incPFA0;
   #define incAk 6
   const int incAm = 0, incAn = -(((Mb) << 5)+((Mb) << 2));
   #define incBk 6
   const int incBm = -36, incBn = 360;
   #define incCm 1
   const int incCn = (((ldc) << 3)+((ldc) << 1)) - (Mb);
   float *pC0=C, *pC1=pC0+(ldc), *pC2=pC1+(ldc), *pC3=pC2+(ldc), *pC4=pC3+(ldc), *pC5=pC4+(ldc), *pC6=pC5+(ldc), *pC7=pC6+(ldc), *pC8=pC7+(ldc), *pC9=pC8+(ldc);
   const float *pA0=A;
   const float *pB0=B;
   register int k;
   register float rA0;
   register float rB0, rB1, rB2, rB3, rB4, rB5, rB6, rB7, rB8, rB9;
   register float rC0_0, rC0_1, rC0_2, rC0_3, rC0_4, rC0_5, rC0_6, rC0_7, rC0_8, rC0_9;
   if (pB0 != stN)
   {
      do /* N-loop */
      {
         do /* M-loop */
         {
            ATL_pfl1R(pfA);
            pfA += incPFA;
            rA0 = beta;
            rC0_0 = *pC0;
            rC0_0 *= rA0;
            rC0_1 = *pC1;
            rC0_1 *= rA0;
            rC0_2 = *pC2;
            rC0_2 *= rA0;
            rC0_3 = *pC3;
            rC0_3 *= rA0;
            rC0_4 = *pC4;
            rC0_4 *= rA0;
            rC0_5 = *pC5;
            rC0_5 *= rA0;
            rC0_6 = *pC6;
            rC0_6 *= rA0;
            rC0_7 = *pC7;
            rC0_7 *= rA0;
            rC0_8 = *pC8;
            rC0_8 *= rA0;
            rC0_9 = *pC9;
            rC0_9 *= rA0;
            for (k=36; k; k -= 6) /* easy loop to unroll */
            {
               rA0 = *pA0;
               rB0 = *pB0;
               rB1 = pB0[36];
               rB2 = pB0[72];
               rB3 = pB0[108];
               rB4 = pB0[144];
               rB5 = pB0[180];
               rB6 = pB0[216];
               rC0_0 += rA0 * rB0;
               rB7 = pB0[252];
               rB8 = pB0[288];
               rB9 = pB0[324];
               rC0_1 += rA0 * rB1;
               rC0_2 += rA0 * rB2;
               rC0_3 += rA0 * rB3;
               rC0_4 += rA0 * rB4;
               rC0_5 += rA0 * rB5;
               rC0_6 += rA0 * rB6;
               rC0_7 += rA0 * rB7;
               rC0_8 += rA0 * rB8;
               rC0_9 += rA0 * rB9;
               rA0 = pA0[1];
               rB0 = pB0[1];
               rB1 = pB0[37];
               rB2 = pB0[73];
               rB3 = pB0[109];
               rB4 = pB0[145];
               rB5 = pB0[181];
               rB6 = pB0[217];
               rC0_0 += rA0 * rB0;
               rB7 = pB0[253];
               rB8 = pB0[289];
               rB9 = pB0[325];
               rC0_1 += rA0 * rB1;
               rC0_2 += rA0 * rB2;
               rC0_3 += rA0 * rB3;
               rC0_4 += rA0 * rB4;
               rC0_5 += rA0 * rB5;
               rC0_6 += rA0 * rB6;
               rC0_7 += rA0 * rB7;
               rC0_8 += rA0 * rB8;
               rC0_9 += rA0 * rB9;
               rA0 = pA0[2];
               rB0 = pB0[2];
               rB1 = pB0[38];
               rB2 = pB0[74];
               rB3 = pB0[110];
               rB4 = pB0[146];
               rB5 = pB0[182];
               rB6 = pB0[218];
               rC0_0 += rA0 * rB0;
               rB7 = pB0[254];
               rB8 = pB0[290];
               rB9 = pB0[326];
               rC0_1 += rA0 * rB1;
               rC0_2 += rA0 * rB2;
               rC0_3 += rA0 * rB3;
               rC0_4 += rA0 * rB4;
               rC0_5 += rA0 * rB5;
               rC0_6 += rA0 * rB6;
               rC0_7 += rA0 * rB7;
               rC0_8 += rA0 * rB8;
               rC0_9 += rA0 * rB9;
               rA0 = pA0[3];
               rB0 = pB0[3];
               rB1 = pB0[39];
               rB2 = pB0[75];
               rB3 = pB0[111];
               rB4 = pB0[147];
               rB5 = pB0[183];
               rB6 = pB0[219];
               rC0_0 += rA0 * rB0;
               rB7 = pB0[255];
               rB8 = pB0[291];
               rB9 = pB0[327];
               rC0_1 += rA0 * rB1;
               rC0_2 += rA0 * rB2;
               rC0_3 += rA0 * rB3;
               rC0_4 += rA0 * rB4;
               rC0_5 += rA0 * rB5;
               rC0_6 += rA0 * rB6;
               rC0_7 += rA0 * rB7;
               rC0_8 += rA0 * rB8;
               rC0_9 += rA0 * rB9;
               rA0 = pA0[4];
               rB0 = pB0[4];
               rB1 = pB0[40];
               rB2 = pB0[76];
               rB3 = pB0[112];
               rB4 = pB0[148];
               rB5 = pB0[184];
               rB6 = pB0[220];
               rC0_0 += rA0 * rB0;
               rB7 = pB0[256];
               rB8 = pB0[292];
               rB9 = pB0[328];
               rC0_1 += rA0 * rB1;
               rC0_2 += rA0 * rB2;
               rC0_3 += rA0 * rB3;
               rC0_4 += rA0 * rB4;
               rC0_5 += rA0 * rB5;
               rC0_6 += rA0 * rB6;
               rC0_7 += rA0 * rB7;
               rC0_8 += rA0 * rB8;
               rC0_9 += rA0 * rB9;
               rA0 = pA0[5];
               rB0 = pB0[5];
               rB1 = pB0[41];
               rB2 = pB0[77];
               rB3 = pB0[113];
               rB4 = pB0[149];
               rB5 = pB0[185];
               rB6 = pB0[221];
               rC0_0 += rA0 * rB0;
               rB7 = pB0[257];
               rB8 = pB0[293];
               rB9 = pB0[329];
               rC0_1 += rA0 * rB1;
               rC0_2 += rA0 * rB2;
               rC0_3 += rA0 * rB3;
               rC0_4 += rA0 * rB4;
               rC0_5 += rA0 * rB5;
               rC0_6 += rA0 * rB6;
               rC0_7 += rA0 * rB7;
               rC0_8 += rA0 * rB8;
               rC0_9 += rA0 * rB9;
               pA0 += incAk;
               pB0 += incBk;
            }
            *pC0 = rC0_0;
            *pC1 = rC0_1;
            *pC2 = rC0_2;
            *pC3 = rC0_3;
            *pC4 = rC0_4;
            *pC5 = rC0_5;
            *pC6 = rC0_6;
            *pC7 = rC0_7;
            *pC8 = rC0_8;
            *pC9 = rC0_9;
            pC0 += incCm;
            pC1 += incCm;
            pC2 += incCm;
            pC3 += incCm;
            pC4 += incCm;
            pC5 += incCm;
            pC6 += incCm;
            pC7 += incCm;
            pC8 += incCm;
            pC9 += incCm;
            pA0 += incAm;
            pB0 += incBm;
         }
         while(pA0 != stM);
         pC0 += incCn;
         pC1 += incCn;
         pC2 += incCn;
         pC3 += incCn;
         pC4 += incCn;
         pC5 += incCn;
         pC6 += incCn;
         pC7 += incCn;
         pC8 += incCn;
         pC9 += incCn;
         pA0 += incAn;
         pB0 += incBn;
      }
      while(pB0 != stN);
   }
   if (k=N-Nb)
      ATL_sJIK0x0x36TN1x1x6_a1_bX(M, k, 36, alpha, ca, lda, cb + (((Nb) << 5)+((Nb) << 2)), ldb, beta, cc + (Nb*ldc), ldc);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
